NAME

OpenAPI::Client::OpenAI::Path::images-generations - Documentation for the /images/generations path.

OPERATIONS

POST /images/generations

createImage

$client->create_image({
    body => { ... },
});

Creates an image given a prompt. Learn more .

Request body

Content-Type: application/json

Example:

{
   "created" : 1713833628,
   "data" : [
      {
         "b64_json" : "..."
      }
   ],
   "usage" : {
      "input_tokens" : 50,
      "input_tokens_details" : {
         "image_tokens" : 40,
         "text_tokens" : 10
      },
      "output_tokens" : 50,
      "total_tokens" : 100
   }
}

Responses

200 - OK

Content-Type: application/json

Example:

{
   "created" : 1713833628,
   "data" : [
      {
         "b64_json" : "..."
      }
   ],
   "usage" : {
      "input_tokens" : 50,
      "input_tokens_details" : {
         "image_tokens" : 40,
         "text_tokens" : 10
      },
      "output_tokens" : 50,
      "total_tokens" : 100
   }
}

Content-Type: text/event-stream

Example:

{
   "created" : 1713833628,
   "data" : [
      {
         "b64_json" : "..."
      }
   ],
   "usage" : {
      "input_tokens" : 50,
      "input_tokens_details" : {
         "image_tokens" : 40,
         "text_tokens" : 10
      },
      "output_tokens" : 50,
      "total_tokens" : 100
   }
}

SCHEMAS

CreateImageRequest

Properties:

  • background (string) - Allows to set transparency for the background of the generated image(s). This parameter is only supported for the GPT image models. Must be one of transparent , opaque or auto (default value). When auto is used, the model will automatically determine the best background for the image.

    If transparent , the output format needs to support transparency, so it should be set to either png (default value) or webp .

    Allowed values: transparent, opaque, auto

    Default: auto

  • model (anyOf) - The model to use for image generation. One of dall-e-2 , dall-e-3 , or a GPT image model (gpt-image-1, gpt-image-1-mini , gpt-image-1.5 ). Defaults to dall-e-2 unless a parameter specific to the GPT image models is used.

    Default: dall-e-2

  • moderation (string) - Control the content-moderation level for images generated by the GPT image models. Must be either low for less restrictive filtering or auto (default value).

    Allowed values: low, auto

    Default: auto

  • n (integer) - The number of images to generate. Must be between 1 and 10. For dall-e-3 , only n=1 is supported.

    Default: 1

  • output_compression (integer) - The compression level (0-100%) for the generated images. This parameter is only supported for the GPT image models with the webp or jpeg output formats, and defaults to 100.

    Default: 100

  • output_format (string) - The format in which the generated images are returned. This parameter is only supported for the GPT image models. Must be one of png , jpeg , or webp .

    Allowed values: png, jpeg, webp

    Default: png

  • partial_images (PartialImages)

    See "PartialImages" below for shape.

  • prompt (string, required) - A text description of the desired image(s). The maximum length is 32000 characters for the GPT image models, 1000 characters for dall-e-2 and 4000 characters for dall-e-3 .

  • quality (string) - The quality of the image that will be generated.

    - auto (default value) will automatically select the best quality for the given model. - high , medium and low are supported for the GPT image models. - hd and standard are supported for dall-e-3 . - standard is the only option for dall-e-2 .

    Allowed values: standard, hd, low, medium, high, auto

    Default: auto

  • response_format (string) - The format in which generated images with dall-e-2 and dall-e-3 are returned. Must be one of url or b64_json . URLs are only valid for 60 minutes after the image has been generated. This parameter isn't supported for the GPT image models, which always return base64-encoded images.

    Allowed values: url, b64_json

    Default: url

  • size (anyOf) - The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21 , arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864 . Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160 . The requested size must also satisfy the model's current pixel and edge limits. The standard sizes 1024x1024 , 1536x1024 , and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2 , use one of 256x256 , 512x512 , or 1024x1024 . For dall-e-3 , use one of 1024x1024 , 1792x1024 , or 1024x1792 .

    Default: auto

  • stream (boolean) - Generate the image in streaming mode. Defaults to false . See the Image generation guide for more information. This parameter is only supported for the GPT image models.

    Default:

  • style (string) - The style of the generated images. This parameter is only supported for dall-e-3 . Must be one of vivid or natural . Vivid causes the model to lean towards generating hyper-real and dramatic images. Natural causes the model to produce more natural, less hyper-real looking images.

    Allowed values: vivid, natural

    Default: vivid

  • user (string) - A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more .

Image

Properties:

  • b64_json (string) - The base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if response_format is set to b64_json for dall-e-2 and dall-e-3 .

  • revised_prompt (string) - For dall-e-3 only, the revised prompt that was used to generate the image.

  • url (string) - When using dall-e-2 or dall-e-3 , the URL of the generated image if response_format is set to url (default value). Unsupported for the GPT image models.

ImageGenInputUsageDetails

Properties:

  • image_tokens (integer, required) - The number of image tokens in the input prompt.

  • text_tokens (integer, required) - The number of text tokens in the input prompt.

ImageGenOutputTokensDetails

Properties:

  • image_tokens (integer, required) - The number of image output tokens generated by the model.

  • text_tokens (integer, required) - The number of text output tokens generated by the model.

ImageGenStreamEvent

See https://platform.openai.com/docs/api-reference for details.

ImageGenUsage

Properties:

  • input_tokens (integer, required) - The number of tokens (images and text) in the input prompt.

  • input_tokens_details (ImageGenInputUsageDetails, required)

    See "ImageGenInputUsageDetails" below for shape.

  • output_tokens (integer, required) - The number of output tokens generated by the model.

  • output_tokens_details (ImageGenOutputTokensDetails)

    See "ImageGenOutputTokensDetails" below for shape.

  • total_tokens (integer, required) - The total number of tokens (images and text) used for the image generation.

ImagesResponse

Properties:

  • background (string) - The background parameter used for the image generation. Either transparent or opaque .

    Allowed values: transparent, opaque

  • created (integer, required) - The Unix timestamp (in seconds) of when the image was created.

  • data (array of Image) - The list of generated images.

  • output_format (string) - The output format of the image generation. Either png , webp , or jpeg .

    Allowed values: png, webp, jpeg

  • quality (string) - The quality of the image generated. Either low , medium , or high .

    Allowed values: low, medium, high

  • size (string) - The size of the image generated. Either 1024x1024 , 1024x1536 , or 1536x1024 .

    Allowed values: 1024x1024, 1024x1536, 1536x1024

  • usage (ImageGenUsage)

    See "ImageGenUsage" below for shape.

PartialImages

The number of partial images to generate. This parameter is used for streaming responses that return partial images. Value must be between 0 and 3. When set to 0, the response will be a single image sent in one streaming event.

Note that the final image may be sent before the full number of partial images are generated if the full image is generated more quickly.

SEE ALSO

OpenAPI::Client::OpenAI::Path

COPYRIGHT AND LICENSE

Copyright (C) 2023-2026 by Nelson Ferraz

This library is free software; you can redistribute it and/or modify it under the same terms as Perl itself, either Perl version 5.14.0 or, at your option, any later version of Perl 5 you may have available.